/*=============================================================================
    Spirit V1.5.0
    Copyright (c) 1998-2002 Spirit-Dev
    http://spirit.sourceforge.net/

    Permission to copy, use, modify, sell and distribute this software
    is granted provided this copyright notice appears in all copies.
    This software is provided "as is" without express or implied
    warranty, and with no claim as to its suitability for any purpose.

    See spirit.hpp for full copyright notices.
=============================================================================*/
#if !defined(SPIRIT_PARSER_ID_HPP)
#define SPIRIT_PARSER_ID_HPP

///////////////////////////////////////////////////////////////////////////////
namespace spirit
{

//////////////////////////////////
class parser_id
{
public:

    parser_id()
    : p(0) {}

    explicit parser_id(void const* prule)
    : p(prule) {}

    parser_id(long l_)
    : l(l_) {}

    bool operator==(parser_id const& x) const
    { return p == x.p; }

    bool operator!=(parser_id const& x) const
    { return !(*this == x); }

    bool operator<(parser_id const& x) const
    { return p < x.p; }

    long to_long() const
    { return l; }

private:

    union
    {
        void const* p;
        long l;
    };

#if defined(SPIRIT_DEBUG)
    friend std::ostream& operator<<(std::ostream& out, parser_id const& rid)
    {
        out << rid.l;
        return out;
    }
#endif
};

} // namespace spirit

///////////////////////////////////////////////////////////////////////////////
#endif

