/*=============================================================================
    Spirit V1.5.0
    Copyright (c) 1998-2002 Spirit-Dev
    http://spirit.sourceforge.net/

    Permission to copy, use, modify, sell and distribute this software
    is granted provided this copyright notice appears in all copies.
    This software is provided "as is" without express or implied
    warranty, and with no claim as to its suitability for any purpose.

    See spirit.hpp for full copyright notices.
=============================================================================*/
#if !defined(SPIRIT_MINIMAL_DEBUG_HPP)
#define SPIRIT_MINIMAL_DEBUG_HPP

#if !defined(SPIRIT_DEBUG_MAIN_HPP)
#error "You must include boost/spirit/debug.hpp, not boost/spirit/debug/minimal.hpp"
#endif
///////////////////////////////////////////////////////////////////////////////
//
//  Minimum debugging tools support
//
///////////////////////////////////////////////////////////////////////////////
#if !defined(SPIRIT_DEBUG_OUT)
#define SPIRIT_DEBUG_OUT std::cout
#endif

///////////////////////////////////////////////////////////////////////////
//
//  SPIRIT_DEBUG_FLAGS controls the level of diagnostics printed
//
///////////////////////////////////////////////////////////////////////////
#if !defined(SPIRIT_DEBUG_FLAGS_NONE)
#define SPIRIT_DEBUG_FLAGS_NONE         0x0000  // no diagnostics at all
#endif

#if !defined(SPIRIT_DEBUG_FLAGS_MAX)
#define SPIRIT_DEBUG_FLAGS_MAX          0xFFFF  // print maximal diagnostics
#endif 

#if !defined(SPIRIT_DEBUG_FLAGS)
#define SPIRIT_DEBUG_FLAGS SPIRIT_DEBUG_FLAGS_MAX
#endif

#if !defined(SPIRIT_DEBUG_PRINT_SOME)
#define SPIRIT_DEBUG_PRINT_SOME 20
#endif

#if !defined(SPIRIT_DEBUG_RULE)
#define SPIRIT_DEBUG_RULE(r)
#endif // !defined(SPIRIT_DEBUG_RULE)

#if !defined(SPIRIT_DEBUG_NODE)
#define SPIRIT_DEBUG_NODE(r)
#endif // !defined(SPIRIT_DEBUG_NODE)

#if !defined(SPIRIT_DEBUG_GRAMMAR)
#define SPIRIT_DEBUG_GRAMMAR(r)
#endif // !defined(SPIRIT_DEBUG_GRAMMAR)

#if !defined(SPIRIT_TRACE_RULE)
#define SPIRIT_TRACE_RULE(r, t)
#endif // !defined(SPIRIT_TRACE_RULE)

#if !defined(SPIRIT_TRACE_NODE)
#define SPIRIT_TRACE_NODE(r, t)
#endif // !defined(SPIRIT_TRACE_NODE)

#if !defined(SPIRIT_TRACE_GRAMMAR)
#define SPIRIT_TRACE_GRAMMAR(r, t)
#endif // !defined(SPIRIT_TRACE_GRAMMAR)

#endif  // !defined(SPIRIT_MINIMAL_DEBUG_HPP)
